stages:
  - build  
  # - test 
  - deploy
  # - dast
  - package

# include: 
#    - template: Code-Quality.gitlab-ci.yml
#    - template: Security/SAST.gitlab-ci.yml
#    - template: Security/Secret-Detection.gitlab-ci.yml
#    - template: Jobs/Dependency-Scanning.gitlab-ci.yml
#    - template: Security/License-Scanning.gitlab-ci.yml
#    - template: DAST.gitlab-ci.yml
   
build-code:
  stage: build
  tags:
    - sh_run
  script:
    - echo "==== Project Building Started ====="
    - mvn clean install
    - echo "code build Successfull..."
    - ls
    - pwd
  artifacts:
    paths:
      - target/*.war

package-artifact:
  stage: package
  tags:
    - sh_run
  script:
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file ${CI_PROJECT_DIR}/target/*.war "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_COMMIT_REF_NAME}/${CI_PIPELINE_IID}/onlinebookstore.war"'
  needs: [build-code]
  rules:
    - if: $CI_PIPELINE_SOURCE == "push"
    
# code_quality:
#   stage: test
#   tags:
#     - doc1
#   variables:
#     REPORT_FORMAT: html
#   artifacts:
#     paths: [gl-code-quality-report.html]
#     reports:
#       codequality: gl-code-quality-report.html
#   # artifacts:
#   #   paths:
#   #     - gl-code-quality-report.json
#   #   reports:
#   #     codequality: gl-code-quality-report.json
#   # when: always

# sast:
#   stage: test
#   tags:
#     - doc1
#   artifacts:
#     name: sast
#     paths:
#       - gl-sast-report.json
#     reports:
#       sast: gl-sast-report.json

# secret_detection:
#   stage: test
#   tags:
#     - doc1
#   variables:
#     SECRET_DETECTION_HISTORIC_SCAN: "true"
#   artifacts:
#     paths:
#       - gl-secret-detection-report.json

# license_scanning:
#   stage: test
#   tags:
#     - doc1
#   dependencies: []
#   variables:
#     LICENSE_MANAGEMENT_VERSION: '4'
#   rules:
#     - if: $LICENSE_MANAGEMENT_DISABLED
#       when: never
#     - if: $CI_COMMIT_BRANCH &&
#           $GITLAB_FEATURES =~ /\blicense_scanning\b/
#   artifacts:
#     paths:
#       - gl-license-scanning-report.json
#     expire_in: never
 
# gemnasium-maven-dependency_scanning:
#   extends:
#     - .ds-analyzer
#     - .cyclonedx-reports
#   variables:
#     DS_ANALYZER_NAME: "gemnasium-maven"
#   stage: test
#   tags:
#     - doc1
#   artifacts:
#     paths:
#      - gl-sbom-*.cdx.json
#      - gl-dependency-scanning-report.json
#     expire_in: never

app_deploy:
    stage: deploy
    environment: prod
    tags:
        - sh_run
    script:
        - cp target/*.war /opt/tomcat/webapps
        - echo " java application succesfully deploy"
        - pwd

# dast:
#   variables:
#     DAST_WEBSITE: http://localhost:8080/onlinebookstore/
#     DAST_FULL_SCAN_ENABLED: "true"
#     DAST_SKIP_TARGET_CHECK: "true"
#   stage: dast
#   tags:
#     - doc1
#   artifacts:
#     paths:
#      - gl-dast-report.json
#     expire_in: never
